<template>
  <div>
    <AddCurrency v-show="isAddCurrencyVisible" @close="closeAddCurrency" @update-currencies="getCurrencies" />
    <EditCurrency
      :currency="currentCurrency"
      v-show="isEditCurrencyVisible"
      @close="closeEditCurrency"
      @update-currencies="getCurrencies"
    />
    <div class="p-6 pb-0">
      <UiButton class="px-4 rounded-16 w-max" @click="openAddCurrency">Add currency</UiButton>
    </div>
    <div class="flex flex-col gap-6 p-6">
      <div v-for="currency in currencies" :key="currency.id" class="w-full rounded-16 bg-bgdtert">
        <CurrencyCard :currency="currency" @edit-currency="handleEditCurrency" @update-currencies="getCurrencies" />
      </div>
    </div>
  </div>
</template>

<script>
import { getCurrencies } from '@/api/admin';
import { disableBodyScroll, enableBodyScroll } from 'body-scroll-lock';

import UiButton from '@/components/ui/UiButton.vue';
import CurrencyCard from '@/components/views/admin/currencies/CurrencyCard.vue';
import AddCurrency from '@/components/views/admin/currencies/AddCurrency.vue';
import EditCurrency from '@/components/views/admin/currencies/EditCurrency.vue';

export default {
  name: 'CurrenciesList',

  components: { UiButton, CurrencyCard, AddCurrency, EditCurrency },

  data() {
    return {
      currencies: [],

      currentCurrency: {},

      isAddCurrencyVisible: false,
      isEditCurrencyVisible: false,
    };
  },

  mounted() {
    this.getCurrencies();
  },

  methods: {
    async getCurrencies() {
      this.$store.commit('setAdminLoading', true);

      try {
        const res = await getCurrencies();
        this.currencies = res.data.results;
      } catch (err) {
        console.error(err);
      } finally {
        this.$store.commit('setAdminLoading', false);
      }
    },

    handleEditCurrency(currency) {
      this.currentCurrency = { ...currency };
      this.openEditCurrency();
    },

    openAddCurrency() {
      this.isAddCurrencyVisible = true;
      const el = document.querySelector('#addCurrency');
      disableBodyScroll(el);
    },

    closeAddCurrency() {
      this.isAddCurrencyVisible = false;
      const el = document.querySelector('#addCurrency');
      enableBodyScroll(el);
    },

    openEditCurrency() {
      this.isEditCurrencyVisible = true;
      const el = document.querySelector('#addCurrency');
      disableBodyScroll(el);
    },

    closeEditCurrency() {
      this.isEditCurrencyVisible = false;
      const el = document.querySelector('#addCurrency');
      enableBodyScroll(el);
    },
  },
};
</script>
